import { createSignal } from "solid-js";

function Colorer(props) {
    const [h, setH] = createSignal(1);
    const [s, setS] = createSignal(50);
    const [l, setL] = createSignal(50);
    const [a, setA] = createSignal(1);
    const hslColor = () => `hsla(${h()}, ${s()}%, ${l()}%, ${a()})`;

    const changeH = (e) => setH(e.currentTarget.value);
    const changeS = (e) => setS(e.currentTarget.value);
    const changeL = (e) => setL(e.currentTarget.value);
    const changeA = (e) => setA(e.currentTarget.value);

    return (
        <div class="main-container">
            <div id="colorer">
                <label>H <input type="number" min="0" max="359"
                    value={h()} onInput={changeH} />
                    <input type="range" min="0" max="359"
                        value={h()} onInput={changeH} />
                </label>
                <label>S <input type="number" min="0" max="100"
                    value={s()} onInput={changeS} />
                    <input type="range" min="0" max="100"
                        value={s()} onInput={changeS} />
                </label>
                <label>L <input type="number" min="0" max="100"
                    value={l()} onInput={changeL} />
                    <input type="range" min="0" max="100"
                        value={l()} onInput={changeL} />
                </label>
                <label>A <input type="number" min="0" max="1" step="0.01"
                    value={a()} onInput={changeA} />
                    <input type="range" min="0" max="1" step="0.01"
                        value={a()} onInput={changeA} />
                </label>
            </div>
            <div class="color-box" style={{
                "background-color": hslColor()
            }}></div>
        </div>
    );
}

function App() {
    return (
        <>
            <header>
                <h1>colorer</h1>
            </header>
            <main>
                <Colorer />
            </main>
        </>
    );
};

export default App;
